package com.qmth.boot.core.retrofit.interfaces;

import com.qmth.boot.core.retrofit.config.RetryProperties;
import org.springframework.boot.logging.LogLevel;

import java.time.Duration;

/**
 * Retrofit客户端配置自定义扩展
 */
public interface CustomizeRetrofitConfiguration {

    class VoidRetrofitConfiguration implements CustomizeRetrofitConfiguration {

    }

    /**
     * 访问地址前缀
     *
     * @return
     */
    default String getBaseUrl() {
        return null;
    }

    /**
     * 启用签名鉴权
     *
     * @return
     */
    default SignatureProvider getSignature() {
        return null;
    }

    /**
     * 自定义连接超时
     *
     * @return
     */
    default Duration getConnectTimeout() {
        return null;
    }

    /**
     * 自定义读数据超时
     *
     * @return
     */
    default Duration getReadTimeout() {
        return null;
    }

    /**
     * 自定义写数据超时
     *
     * @return
     */
    default Duration getWriteTimeout() {
        return null;
    }

    /**
     * 自定义重试配置
     *
     * @return
     */
    default RetryProperties getRetryProperties() {
        return null;
    }

    /**
     * 自定义日志级别
     *
     * @return
     */
    default LogLevel getLogLevel() {
        return null;
    }

}
